#ifndef __ILI9341_H
#define __ILI9341_H		
#include "sys.h"	 
#include "stdlib.h"

//LCD9341Ҫ
typedef struct  
{										    
	u16 width;			//LCD9341 
	u16 height;			//LCD9341 ߶
	u16 id;				//LCD9341 ID
	u8  dir;			//ƣ01	
	u8	wramcmd;		//ʼдgramָ
	u8  setxcmd;		//xָ
	u8  setycmd;		//yָ	 
}_lcd_dev; 	  

//LCD9341
extern _lcd_dev lcddev;	//LCD9341Ҫ
//LCD9341Ļɫͱɫ	   
extern u16  POINT_COLOR;//ĬϺɫ    
extern u16  BACK_COLOR; //ɫ.ĬΪɫ


//////////////////////////////////////////////////////////////////////////////////	 
//-----------------LCD9341˿ڶ---------------- 
#define	LCD9341_LED PBout(0) //LCD9341    		 PB0 	    
//LCD9341ַṹ
typedef struct
{
	u16 LCD9341_REG;//(u32)(0x6C0007FE)
	u16 LCD9341_RAM;//(u32)(0x6C000800)=0x6C0007FE+2ֽ
} LCD9341_TypeDef;
//ʹNOR/SRAM Bank1.sector4,ַλHADDR[27,26]=11 A10Ϊ 
//עʱSTM32ڲһλ! 111110=0X3E			    
#define LCD9341_BASE        ((u32)(0x6C000000 | 0x000007FE))
#define LCD9341             ((LCD9341_TypeDef *) LCD9341_BASE)
	 
//ɨ跽
#define L2R_U2D  0 //,ϵ
#define L2R_D2U  1 //,µ
#define R2L_U2D  2 //ҵ,ϵ
#define R2L_D2U  3 //ҵ,µ

#define U2D_L2R  4 //ϵ,
#define U2D_R2L  5 //ϵ,ҵ
#define D2U_L2R  6 //µ,
#define D2U_R2L  7 //µ,ҵ	 

#define DFT_SCAN_DIR  L2R_U2D  //Ĭϵɨ跽

//ɫ
#define WHITE         	 0xFFFF
#define BLACK         	 0x0000	  
#define BLUE         	 0x001F  
#define BRED             0XF81F
#define GRED 			 0XFFE0
#define GBLUE			 0X07FF
#define RED           	 0xF800
#define MAGENTA       	 0xF81F
#define GREEN         	 0x07E0
#define CYAN          	 0x7FFF
#define YELLOW        	 0xFFE0
#define BROWN 			 0XBC40 //ɫ
#define BRRED 			 0XFC07 //غɫ
#define GRAY  			 0X8430 //ɫ
//GUIɫ

#define DARKBLUE      	 0X01CF	//ɫ
#define LIGHTBLUE      	 0X7D7C	//ǳɫ  
#define GRAYBLUE       	 0X5458 //ɫ
//ɫΪPANELɫ 
 
#define LIGHTGREEN     	 0X841F //ǳɫ
//#define LIGHTGRAY        0XEF5B //ǳɫ(PANNEL)
#define LGRAY 			 0XC618 //ǳɫ(PANNEL),屳ɫ

#define LGRAYBLUE        0XA651 //ǳɫ(мɫ)
#define LBBLUE           0X2B12 //ǳɫ(ѡĿķɫ)
	    															  
void LCD9341_Init(void);											//ʼ
void LCD9341_DisplayOn(void);										//ʾ
void LCD9341_DisplayOff(void);										//ʾ
void LCD9341_Clear(u16 Color);	 									//
void LCD9341_SetCursor(u16 Xpos, u16 Ypos);							//ù
void LCD9341_DrawPoint(u16 x,u16 y);								//
void LCD9341_Fast_DrawPoint(u16 x,u16 y,u16 color);					//ٻ
u16  LCD9341_ReadPoint(u16 x,u16 y); 								// 
void LCD9341_Draw_Circle(u16 x0,u16 y0,u8 r);						//Բ
void LCD9341_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2);				//
void LCD9341_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2);		   	//
void LCD9341_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 color);		   	//䵥ɫ
void LCD9341_Color_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color);	//ָɫ
void LCD9341_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode);						//ʾһַ
void LCD9341_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size);  						//ʾһ
void LCD9341_ShowxNum(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode);				//ʾ 
void LCD9341_ShowString(u16 x,u16 y,u16 width,u16 height,u8 size,u8 *p);		//ʾһַ,12/16


void LCD9341_WriteReg(u8 LCD9341_Reg, u16 LCD9341_RegValue);
u16  LCD9341_ReadReg(u8 LCD9341_Reg);
void LCD9341_WriteRAM_Prepare(void);
void LCD9341_WriteRAM(u16 RGB_Code);		  
void LCD9341_Scan_Dir(u8 dir);							//ɨ跽
void LCD9341_Display_Dir(u8 dir);						//Ļʾ

#endif  
	 
	 



